% Tom Gradel - CIS 601 - Homework#1
%------------------------------------

% getframe extract an image 1 pixel wider, and we want a
% multiple of 4 here.
windowPos = [100 100 400 400];
writeAVI = 1;
showFigure = 'on';

if (writeAVI ~= 0)
    aviobj = avifile('gradelA.avi', 'fps', 1, 'Compression', 'Indeo5');
end

% Start with a geometric figure
[x,y,z] = cylinder;

% Change x,y,z to matrix notation and suffix with 1's
m = [[x(1,:) x(2,:)];[y(1,:) y(2,:)];[z(1,:) z(2,:)];ones(1,size(x,1)*size(x,2))];

% Use simple grayscale shading matrix for rendering
I = uint8(repmat(0:255,256,1));

% show text
h = figure('Position', windowPos, ...
           'Color', 'w', ...
           'NextPlot','replace', ...
           'Visible', showFigure);
aviobj = showText(h, 1, aviobj, writeAVI);
aviobj = showText(h, 2, aviobj, writeAVI);

% Do translation
for dx = 0:1
    for dy = 0:1
        for dz = 0:1
            % Setup for render
            clf;
            set(gca,'xlim',[-1 2],'ylim',[-1 2],'zlim',[0 2],...
                'NextPlot','replace', 'Visible','on');
            hold on;

            % Do the math
            t = setTranslate([dx dy dz]);
            [x,y,z] = simpleTranslate(m,t);

            % Render
            warp(x,y,z,I);

            % Captured rendered frame to movie
            if (writeAVI ~= 0)
                aviobj = addframe(aviobj, getframe);
            end
        end
    end
end

% Do scaling
aviobj = showText(h, 3, aviobj, writeAVI);
for scale = 1:-.2:.1
    clf;
    set(gca,'xlim',[-1 2],'ylim',[-1 2],'zlim',[0 2],...
        'NextPlot','replace');
    hold on;

    % Do the math
    t = setScale([scale scale scale]);
    [x,y,z] = simpleTranslate(m,t);

    % Render
    warp(x,y,z,I);

    % Captured rendered frame to movie
    if (writeAVI ~= 0)
        aviobj = addframe(aviobj, getframe);
    end
end

% Do rotation about zero
for axis = 0:2

    if (axis == 0)
        axisChar = 'x';
        aviobj = showText(h, 4, aviobj, writeAVI);
    else if (axis == 1)
        axisChar = 'y';
        aviobj = showText(h, 5, aviobj, writeAVI);
    else
        axisChar = 'z';
        aviobj = showText(h, 6, aviobj, writeAVI);
    end
    end

    for theta = 0 : pi/8 : 2 * pi
        clf;
        set(gca,'xlim',[-1 2],'ylim',[-1 2],'zlim',[0 2],...
            'NextPlot','replace','Visible','on');
        hold on;

        % Do the math (object centered at [0,0,0.5])
        t = setTranslate([0 0 0.5]) ...
            * setRotate(axisChar, theta) ...
            * setTranslate([0 0 -0.5]);
        [x,y,z] = simpleTranslate(m,t);

        % Render
        warp(x,y,z,I);

        % Captured rendered frame to movie
        if (writeAVI ~= 0)
            aviobj = addframe(aviobj, getframe);
        end
    end
end

aviobj = showText(h, 9, aviobj, writeAVI);

if (writeAVI ~= 0)
    aviobj = close(aviobj);
end
close(h);

